stories/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('story7.urls')),
]

story7/urls.py
from django.urls import path
from . import views

app_name = 'story7'

urlpatterns = [
    path('', views.landingPage, name='landingPage'),
    path('accordion/', views.accordion, name='accordion'),
    path('bookshelves/', views.bookshelves, name='bookshelves'),
    path('bookshelves/api/books/<str:book>/', views.retrieve, name='retrieve'),
    path('signup/', views.signupFunc, name='signup'),
    path('login/', views.loginFunc, name='login'),
    path('logout/', views.logOut, name='logout'),
]

story7/models.py
from django.db import models

# Create your models here.

story7/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm


class LoginForm(AuthenticationForm):
    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class': 'form-control',
        'id': 'signIn-username',
        'placeholder': 'Username',
        'type': 'text',
        'style': 'width: 30vw;',
        'required': True
    }))

    password = forms.CharField(label="Password", widget=forms.TextInput(attrs={
        'class': 'form-control',
        'id': 'signIn-password',
        'placeholder': 'Password',
        'type': 'password',
        'style': 'width: 30vw;',
        'required': True
    }))


class SignUpForm(UserCreationForm):

    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class': 'form-control',
        'id': 'signUp-username',
        'placeholder': 'Username',
        'type': 'text',
        'style': 'width: 30vw;',
        'required': True
    }))

    password1 = forms.CharField(label="Password", widget=forms.PasswordInput(attrs={
        'class': 'form-control',
        'id': 'signUp-password1',
        'placeholder': 'Password',
        'type': 'password',
        'style': 'width: 30vw;',
        'required': True
    }))
    password2 = forms.CharField(label="Confirm password", widget=forms.PasswordInput(attrs={
        'class': 'form-control',
        'id': 'signUp-password2',
        'placeholder': 'Confirm Password',
        'type': 'password',
        'style': 'width: 30vw;',
        'required': True
    }))


class Meta:
    model = User
    fields = ['first_name', 'last_name', 'username', 'password1', 'password2']

story7/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.shortcuts import render, redirect
from .forms import LoginForm, SignUpForm
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
import json
import requests

# Create your views here.


def landingPage(request):
    return render(request, 'landingPage.html')


def accordion(request):
    return render(request, 'accordion.html')


def bookshelves(request):
    return render(request, 'bookshelves.html')


def retrieve(request, book):
    argReq = requests.get(
        "https://www.googleapis.com/books/v1/volumes?q=" + book)
    data = argReq.json()
    data = json.dumps(data)
    print(data)
    return HttpResponse(content=data, content_type="application/json")

# story 9


def loginFunc(request):
    if request.method == "POST":
        form = LoginForm(data=request.POST)

        if form.is_valid():
            usernameInput = request.POST["username"]
            passwordInput = request.POST["password"]

            print(usernameInput, passwordInput)
            user = authenticate(
                request, username=usernameInput, password=passwordInput)

            if user is not None:
                login(request, user)
                return redirect('story7:login')

        else:
            messages.error(request, 'Invalid entry')

    else:
        form = LoginForm()

    context = {
        "form": form,
    }

    return render(request, 'login.html', context)


def signupFunc(request):
    if request.method == 'POST':
        form = SignUpForm(request.POST)

        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect("story7:login")

        else:
            for msg in form.error_messages:
                messages.error(request, 'Invalid entry')

    else:
        form = SignUpForm()

    context = {
        'form': form
    }

    return render(request, 'signup.html', context)


def logOut(request):
    logout(request)
    print("halo")
    return redirect('story7:login')

story7/templates/accordion.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Accordion Page!</title>
    <link rel="stylesheet" type="text/css" href="{% static 'accordion.css' %}">
    <script src="{% static 'accordion.js' %}"></script>
</head>

<body>
    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>

    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <p id="top">Welcome to my Accordion Page for
                    Story 7!</p>
            </div>
        </div>

        <div class="accordion" id="accordionExample">
            <div id="0">
                <div class="card">
                    <div class="card-header" id="headingZero">
                        <h2 class="mb-0 0">
                            <button class="btn btn-link" type="button" data-toggle="collapse"
                                data-target="#collapseZero" aria-controls="collapseZero">
                                About Erika!
                            </button>
                            <button class="btn up up0" type="button">^</button>
                            <button class="btn down down0" type="button">⌄</button>
                        </h2>
                    </div>

                    <div id="collapseZero" class="collapse" aria-labelledby="headingZero"
                        data-parent="#accordionExample">
                        <div class="card-body">
                            <p>Erika is an undergraduate computer science student majoring in Information System at
                                University of Indonesia. She's currently a lil bit suffering while learning coding but
                                she's trying her best to stick around. Go support her by sending her sweet message at
                                Instagram @eriiiikaa !</p>
                        </div>
                    </div>
                </div>
            </div>
            <div id="1">
                <div class="card">
                    <div class="card-header genap" id="headingOne">
                        <h2 class="mb-0">
                            <button class="btn btn-link genap" type="button" data-toggle="collapse"
                                data-target="#collapseOne" aria-controls="collapseOne">
                                Organization and Comitee Experiences
                            </button>
                            <button class="btn up up1" type="button">^</button>
                            <button class="btn down down1" type="button">⌄</button>
                        </h2>
                    </div>

                    <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordionExample">
                        <div class="card-body">
                            <p> Staff of Academic and Leadership Department at BEM Fakultas Ilmu Komputer Universitas
                                Indonesia </p>
                            <p> Head of State Defense Department at OSIS SMP Avicenna Jagakarsa 2015</p>
                            <p> Vice Person in Charge of Events at PMB Fasilkom UI 2020 </p>
                            <p> Media Partner Team at OKK UI 2020</p>
                            <p> Startup Academy Team at COMPFEST 12</p>
                            <p> Events Team at Wisuda Ganjil Fasilkom 2020</p>
                            <p> Field Coordinator Team at PERAK Fasilkom UI 2019</p>
                            <p> Public Relation and Partnership Team at BETIS Fasilkom UI 2019</p>
                            <p> Public Relation and Publication Team at OH Fasilkom UI 2019</p>
                            <p> Events Team at SMANSA Model United Nation 2017</p>
                        </div>
                    </div>
                </div>
            </div>

            <div id="2">
                <div class="card">
                    <div class="card-header" id="headingTwo">
                        <h2 class="mb-0">
                            <button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseTwo"
                                aria-controls="collapseTwo">
                                Achievements
                            </button>
                            <button class="btn up up2" type="button">^</button>
                            <button class="btn down down2" type="button">⌄</button>
                        </h2>
                    </div>

                    <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                        <div class="card-body">
                            <p>Silver Medalist of Kyorugi at Jakarta Taekwondo Festival 2017</p>
                            <p>First winner of Book Review Competition at Avicenna's Competition 2016</p>
                            <p>OSP DKI Jakarta Cabang Matematika 2014</p>
                            <p>O2SK Jagakarsa Renang Gaya Bebas 500m 2014</p>
                        </div>
                    </div>
                </div>
            </div>

            <div id="3">
                <div class="card">
                    <div class="card-header genap" id="headingThree">
                        <h2 class="mb-0">
                            <button class="btn btn-link genap" type="button" data-toggle="collapse"
                                data-target="#collapseThree" aria-controls="collapseThree">
                                Interest
                            </button>
                            <button class="btn up up3" type="button">^</button>
                            <button class="btn down down3" type="button">⌄</button>
                        </h2>
                    </div>

                    <div id="collapseThree" class="collapse" aria-labelledby="headingThree"
                        data-parent="#accordionExample">
                        <div class="card-body">
                            <p>Criminology</p>
                            <p>Forensic Psychology</p>
                            <p>Cyber Crime</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>
        var acc = document.getElementsByClassName("btn-link");
        var i;

        for (i = 0; i < acc.length; i++) {
            acc[i].addEventListener("click", function () {
                /* Toggle between adding and removing the "active" class,
                to highlight the button that controls the panel */
                this.parentElement.parentElement.classList.toggle("active")

                /* Toggle between hiding and showing the active panel */
                var panel = this.parentElement.parentElement.nextElementSibling;
                if (panel.style.display === "block") {
                    panel.style.display = "none";
                } else {
                    panel.style.display = "block";
                }
            });
        }
    </script>

</body>

</html>

story7/templates/bookshelves.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Search Page!</title>
    <link rel="stylesheet" type="text/css" href="{% static 'bookshelves.css' %}">
</head>

<body>

    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>
    <p id="title">
        Search any books!
    </p>
    <section id="query-section" class="text-center container">
        <input id="keyword" ,placeholder="Place your keyword here">
    </section>

    <section id="catalogue-section" class="text-center container">
        <table class="table table-striped table-dark">
            <thead>
                <tr class="title">
                    <th scope="col">Image</th>
                    <th scope="col">Title</th>
                    <th scope="col">Author</th>
                </tr>
            </thead>
            <tbody id="table-body">
                <!-- content goes here -->
            </tbody>
        </table>
    </section>


    <ol id="result">
    </ol>

    <script type="text/javascript">
        //console.log("js masuk");
        $("#keyword").keyup(function () {
            var keyword_value = $("#keyword").val()
            //console.log(keyword_value)
            var called_url = 'api/books/' + keyword_value;
            //console.log(keyword_value)
            $('#table-body').empty()
            $.ajax({
                url: called_url,
                dataType: 'json',
                type: 'GET',
                success: function (result) {
                    //console.log(result.items)
                    let table_container = $('#table-body')
                    var result_object = $("#result");
                    result_object.empty();
                    for (i = 0; i < result.items.length; i++) {
                        var title_tmp = result.items[i].volumeInfo.title;
                        var thumbnail_tmp = result.items[i].volumeInfo.imageLinks.smallThumbnail;
                        var author_tmp = result.items[i].volumeInfo.authors;
                        //console.log(title_tmp)
                        console.log(author_tmp)
                        let imgCol = '<th scope="row"><img height="150px" width="100px" src="' + thumbnail_tmp + '"></img></th>'
                        let titleCol = '<td class="title-col"><p>' + title_tmp + '</p></td>'
                        let authorCol = '<td class="author-col"><p>' + author_tmp + '</p></td>'
                        table_container.append('<tr>' + imgCol + titleCol + authorCol + '</tr>');
                    }
                }
            })
        });
    </script>

</body>



</html>

story7/templates/hello.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Welcome Back!</title>
    <link rel="stylesheet" type="text/css" href="{% static 'story9.css' %}">
</head>

<body>

    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>

    <div class="greeting">
        <h1>Hello {{request.user}} !</h1>
        <span>If you wanna logout here you go baby -></span>
        <a style="color: #1abcbd;" href="{% url 'story7:logout' %}" id="logout">Logout</a>
    </div>

</body>

</html>

story7/templates/landingPage.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{% static 'landingPage.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Erika's stories!</title>
</head>

<body>
    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>
    <p class="hi">
        Hi! Welcome to Erika's Stories
    </p>
</body>

</html>

story7/templates/login.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Welcome Back!</title>
    <link rel="stylesheet" type="text/css" href="{% static 'story9.css' %}">
</head>

<body>

    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>

    <p class="login"> Log In </p>

    <div class="row ">


        <div class="right-page col">

            {% if user.is_authenticated == False %}
            <div class="login content mx-5 my-3">
                {% if messages %}
                {% for message in messages %}
                <p>{{message}}</p>
                {% endfor %}
                {% endif %}

                <div class="login-form">
                    <form method="POST">
                        {% csrf_token %}
                        {{ form }}
                        <div>
                            <button type="submit" name="btn-login" id="btn-logIn" class="buttonlogin">LOGIN</button>
                        </div>
                    </form>
                </div>

                <div class="info mt-5">
                    <p class="dont">
                        Don't have an account yet? <a class="dont2" href="{% url 'story7:signup' %}">Sign
                            up.</a>
                    </p>
                </div>
            </div>

            {% else %}

            <div class="success mt-5 ml-5">

                <div class="greeting mt-5">
                    <p id="welcome">Welcome,</p>
                    <p class="name"><span class="highlight">{{user.username}}</span></p>
                </div>

                <div class="btn-logout">
                    <form action="{% url 'story7:logout' %}">
                        <p>Wondering where the log out button is? <span> <input type="submit" class="logout"
                                    value="Log out"></span></p>
                    </form>
                </div>


            </div>
            {% endif %}

        </div>
    </div>

</body>

</html>

story7/templates/signup.html
<!DOCTYPE html>
{% load static %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Nerko+One&family=Quicksand:wght@500&display=swap"
        rel="stylesheet">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
        integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
        crossorigin="anonymous"></script>
    <title>Welcome!</title>
    <link rel="stylesheet" type="text/css" href="{% static 'story9.css' %}">
</head>

<body>

    <nav class="navbar">
        <div class="container-fluid">
            <ul class="nav navbar-nav">
                <li class="header"><a href="{% url 'story7:landingPage' %}">Home</a></li>
                <li class="header"><a href="{% url 'story7:accordion' %}">Accordion Page</a></li>
                <li class="header"><a href="{% url 'story7:bookshelves' %}">Search Book</a></li>
                <li class="header"><a href="{% url 'story7:login' %}">Log In</a></li>
            </ul>
        </div>
    </nav>

    <p class="signup"> Sign Up </p>
    <p id="create">Hello! Create your account by filling out this form.</p>

    <div class="main-story9 d-flex flex-column justify-content-center">
        {% if messages %}
        {% for message in messages %}
        <p>{{message}}</p>
        {% endfor %}
        {% endif %}

        <div class="row">

            <div class="right-page col">
                <div class="login-content mx-5 ">

                    <div class="register-form">
                        <form method="POST">
                            {% csrf_token %}
                            {{ form }}
                            <div>
                                <button type="submit" name="btn-signup" id='btn-signUp' class="buttonsignup">SIGN
                                    UP</button>
                            </div>
                        </form>
                    </div>

                    <div class="already">
                        <p>
                            Already have an account? <a class="already2" href="{% url 'story7:login' %}">Log
                                in.</a>
                        </p>
                    </div>
                </div>
            </div>
        </div>

</body>

</html>